program Prepare1;

uses SQLite3, GPC;

var
  Err: TString;
  MyDb: TSQLite3;
  Stmnt: TSQLite3Statement;

begin
  if SQLite3Open ('prepare1.db', MyDb) = SQLITE_OK then
    begin
      Write ('Database ''prepare1.db'' successfully opened. Now we insert some data with ''SQLite3Exec''...');
      if SQLite3Exec (MyDb, 'CREATE TABLE animals (name TEXT, type TEXT); INSERT INTO animals VALUES (''Felix'', ''Hamster'');INSERT INTO animals VALUES (''Piti'', ''Bird'');', Nil, Nil, Err) <> SQLITE_OK then
        begin
          WriteLn;
          WriteLn ('ERROR: ', Err)
        end;
      WriteLn ('done.');
      if SQLite3Prepare (MyDb, 'SELECT * FROM animals WHERE $col = $value', -1, Stmnt, Err) <> SQLITE_OK then
        begin
          WriteLn ('ERROR: Cannot prepare statement: ', Err);
          Halt
        end;
      WriteLn ('Number of parameters in precompiled statements: ', SQLite3BindParameterCount (Stmnt));
      WriteLn ('Parameter ''$col'' is parameter number ', SQLite3BindParameterIndex (Stmnt, '$col'), '.');
      WriteLn ('Parameter 2 has the name ''', SQLite3BindParameterName (Stmnt, 2), '''.');
    end
  else
    begin
      WriteLn ('ERROR: Something wrong, cannot open database');
      Halt 
    end;
  SQLite3Close (MyDb)
end.
